unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ifc_ldev,ioctl,
  StdCtrls, ExtCtrls, create;


const
   FIFO = 1024;
   IrqStep = 1024;
   pages = 32;

type
  WA = array [0..512000] of USHORT;
  PWA = ^WA;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  pLDev: IDaqLDevice;
  pIUnknown:LUnknown;
  hr:Integer;
  sl:SLOT_PAR;
  dev: THandle;
  pd: PLATA_DESCR_1450;
  ap: ADC_PAR;
  tm: ULONG;
  data:PWA;
  sync:PULONG;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var s:string;
begin
   s:=IntToStr(pLDev.LoadBios('l1450'));

   Memo1.Lines.Add('LoadBios status '+s);
   s:= IntToStr(pLDev.PlataTest);
   Memo1.Lines.Add('PlataTest status '+s);

   s:=IntToStr(pLDev.ReadPlataDescr(pd));

   Memo1.Lines.Add('ReadPlataDescr status '+s);

   Memo1.Lines.Add('');
   Memo1.Lines.Add('Serial Num. '+pd.SerNum);
   Memo1.Lines.Add('Board Name '+pd.BrdName);
   Memo1.Lines.Add('Revision '+pd.Rev);
   Memo1.Lines.Add('DSP Type '+pd.DspType);
   Memo1.Lines.Add('Quartz '+IntToStr(pd.Quartz));
//   Memo1.Lines.Add('IsDacPresent '+IntToStr(pd.IsDacPresent));
   Memo1.Lines.Add('');

   pLDev.GetSlotParam(sl);

   Memo1.Lines.Add('');
   Memo1.Lines.Add('Slot parameters');
   Memo1.Lines.Add('Base - '+IntToHex(sl.Base,4));
   Memo1.Lines.Add('BaseL - '+IntToHex(sl.BaseL,4));
   Memo1.Lines.Add('Mem - '+IntToHex(sl.Mem,8));
   Memo1.Lines.Add('MemL - '+IntToHex(sl.MemL,8));
   Memo1.Lines.Add('Type - '+IntToStr(sl.BoardType));
   Memo1.Lines.Add('DSPType - '+IntToStr(sl.DSPType));
   Memo1.Lines.Add('Irq - '+IntToStr(sl.Irq));

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   ap.t1.s_Type := L_ADC_PARAM;
   ap.t1.AutoInit := 1;
   ap.t1.dRate := 20.0;
   ap.t1.dKadr := 0.0;
   ap.t1.dScale := 0;
   ap.t1.SynchroType := 3;
   ap.t1.SynchroSensitivity := 0;
   ap.t1.SynchroMode := 0;
   ap.t1.AdChannel := 0;
   ap.t1.AdPorog := 0;
   ap.t1.NCh := 4;
   ap.t1.Chn[0] := $0;
   ap.t1.Chn[1] := $1;
   ap.t1.Chn[2] := $2;
   ap.t1.Chn[3] := $3;
   ap.t1.FIFO := FIFO;
   ap.t1.IrqStep := IrqStep;
   ap.t1.Pages := pages;
   ap.t1.IrqEna := 1;
   ap.t1.AdcEna := 1;

   pLDev.FillDAQparameters(ap.t1);

   tm := 100000;  //   100000 
   pLDev.RequestBufferStream(tm,L_STREAM_ADC);

   Memo1.Lines.Add('Allocated memory size(word) : '+IntToStr(tm));

   pLDev.SetParametersStream(ap.t1, tm, data, sync,L_STREAM_ADC);

   Memo1.Lines.Add('Buffer size(word): '+IntToStr(tm));
   Memo1.Lines.Add('Pages: '+IntToStr(ap.t1.Pages));
   Memo1.Lines.Add('Rate: '+FloatToStr(ap.t1.dRate));
   Timer1.Enabled:=True;
   pLDev.InitStartLDevice;
   pLDev.StartLDevice;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   Timer1.Enabled:=False;

   Memo1.Lines.Clear;
   Memo1.Lines.Add('Testing library');
   if(CallCreateInstance('lcomp.dll')=1) then
   begin
      Memo1.Lines.Add('Loading library - success.');
      Memo1.Lines.Add('');
   end;

   pIUnknown:=CreateInstance(1);
   hr := pIUnknown.QueryInterface(IID_ILDEV,pLDev);
   if(not Succeeded(hr)) then MessageBox(0,'Get interface failed','Error',MB_OK);
   pIUnknown.Release;
   dev:=pLDev.OpenLDevice;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   Timer1.Enabled:=False;
   pLDev.StopLDevice;
   pLDev.CloseLDevice;
   pLDev.Release;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   Memo1.Lines.Add('Sync: '+IntToStr(sync^));
end;

end.
